Index: trunk/lib/Prefs.inc.php
===================================================================
--- trunk/lib/Prefs.inc.php	(revision 124)
+++ trunk/lib/Prefs.inc.php	(revision 136)
@@ -1,42 +1,28 @@
 <?php
 /**
- * Prefs:: provides an API for saving arbitrary values in a user's session.
- * Database save routines to come.
+ * Prefs.inc.php
+ * code by strangecode :: www.strangecode.com :: this document contains copyrighted information
  *
- * @inspiration  Horde 2.0's Prefs class. This one is much simpler, but
- *               the API for the methods that exist are sort of like Horde's
- *               in case we want to be more like it in the future.
+ * Prefs provides an API for saving arbitrary values in a user's session.
+ *
  * @author  Quinn Comendant <quinn@strangecode.com>
- * @version 1.1
+ * @version 2.1
  */
 class Prefs {
 
-    /**
-     * Where these preferences can be used. To differentiate between preferences
-     * for a specific script, application, or global.
-     * @var string $scope
-     */
-    var $scope = 'global';
-
-    /**
-     * Indicator whether we save in the database or not.
-     * @var boolean $_perpetual
-     */
-    var $_perpetual = false;
-
-    /**
-     * Hash containing connection parameters.
-     * @var array $params
-     */
-    var $params = array();
-
+    // Namespace of this instance of Prefs.
+    var $_ns;
 
     /**
      * Prefs constructor.
      */
-    function Prefs($dbh=false, $params=array())
+    function Prefs($namespace='')
     {
-        $this->params = $params;
-        $_perpetual = false; // Until database routines are completed.
+        $this->_ns = '_prefs_' . $namespace;
+        
+        // Initialized the prefs array.
+        if (!isset($_SESSION[$this->_ns])) {
+            $_SESSION[$this->_ns] = array();
+        }
     }
 
@@ -45,39 +31,12 @@
      * is not set already.
      *
-     * @param  string $pref      The name of the preference to modify.
+     * @param  string $key       The name of the preference to modify.
      * @param  string $val       The new value for this preference.
-     * @param  string $scope     The scope for this preference.
-     *
-     * @return boolean  True if the value was successfully set.
      */
-    function setDefault($pref, $val, $scope=null)
+    function setDefault($key, $val)
     {
-        if (!isset($scope)) {
-            $scope =& $this->scope;
-        }
-
-        // No empty values allowed.
-        if ('' == $pref || '' == $val || '' == $scope) {
-            return false;
-        }
-
-        // Initialized the prefs array.
-        if (!isset($_SESSION['_prefs'])) {
-            $_SESSION['_prefs'] = array();
-        }
-
-        // In case boolean or null values are passed as a string.
-        if ($val == 'true') {
-            $val = true;
-        } else if ($val == 'false') {
-            $val = false;
-        } else if ($val == 'null') {
-            $val = null;
-        }
-
         // Set it only if not set already.
-        if (!isset($_SESSION['_prefs'][$scope][$pref])) {
-            $_SESSION['_prefs'][$scope][$pref] = $val;
-            return true;
+        if (!isset($_SESSION[$this->_ns][$key])) {
+            $_SESSION[$this->_ns][$key] = $val;
         }
     }
@@ -86,37 +45,10 @@
      * Sets the given preferences to the specific value,
      *
-     * @param  string $pref      The name of the preference to modify.
+     * @param  string $key       The name of the preference to modify.
      * @param  string $val       The new value for this preference.
-     * @param  string $scope     The scope for this preference.
-     *
-     * @return boolean  True if the value was successfully set.
      */
-    function setValue($pref, $val, $scope=null)
+    function set($key, $val)
     {
-        if (!isset($scope)) {
-            $scope =& $this->scope;
-        }
-
-        // No empty values allowed.
-        if ('' == $pref || '' == $val || '' == $scope) {
-            return false;
-        }
-
-        // Initialized the prefs array.
-        if (!isset($_SESSION['_prefs'])) {
-            $_SESSION['_prefs'] = array();
-        }
-
-        // In case boolean or null values are passed as a string.
-        if ($val == 'true') {
-            $val = true;
-        } else if ($val == 'false') {
-            $val = false;
-        } else if ($val == 'null') {
-            $val = null;
-        }
-
-        $_SESSION['_prefs'][$scope][$pref] = $val;
-        return true;
+        $_SESSION[$this->_ns][$key] = $val;
     }
 
@@ -124,16 +56,11 @@
      * Returns the value of the requested preference.
      *
-     * @param string $pref      The name of the preference to retrieve.
-     * @param string $scope     The scope for this preference.
+     * @param string $key       The name of the preference to retrieve.
      *
      * @return string           The value of the preference.
      */
-    function getValue($pref, $scope=null)
+    function get($key)
     {
-        if (!isset($scope)) {
-            $scope =& $this->scope;
-        }
-
-        return (isset($_SESSION['_prefs'][$scope][$pref])) ? $_SESSION['_prefs'][$scope][$pref] : null;
+        return (isset($_SESSION[$this->_ns][$key])) ? $_SESSION[$this->_ns][$key] : null;
     }
 
@@ -141,17 +68,12 @@
      * To see if a preference has been set.
      *
-     * @param string $pref      The name of the preference to check.
-     * @param string $scope     The scope for this preference.
+     * @param string $key       The name of the preference to check.
      *
      * @return boolean          True if the preference isset and not empty
      *                          false otherwise.
      */
-    function exists($pref, $scope=null)
+    function exists($key)
     {
-        if (!isset($scope)) {
-            $scope =& $this->scope;
-        }
-
-        return isset($_SESSION['_prefs'][$scope][$pref]);
+        return isset($_SESSION[$this->_ns][$key]);
     }
 
@@ -159,75 +81,11 @@
      * Clear a set preference value.
      *
-     * @param string $pref      The name of the preference to check.
-     * @param string $scope     The scope for this preference.
+     * @param string $key       The name of the preference to check.
      */
-    function clearValue($pref, $scope=null)
+    function delete($key)
     {
-        if (!isset($scope)) {
-            $scope =& $this->scope;
+        if (isset($_SESSION[$this->_ns][$key])) {
+            unset($_SESSION[$this->_ns][$key]);
         }
-
-        if (isset($_SESSION['_prefs'][$scope][$pref])) {
-            unset($_SESSION['_prefs'][$scope][$pref]);
-        }
-    }
-
-    /**
-     * Retrieves the requested set of preferences from the user's database
-     * entry.
-     *
-     * @param optional array $prefs  An array listing the preferences to
-     *                     retrieve. If not specified, retrieve all of the
-     *                     preferences listed in the $prefs hash.
-     *
-     * @return mixed       True on success or a PEAR_Error object on failure.
-     */
-    function retrieve()
-    {
-        // Check that we don't have the preferences loaded yet.
-        if ($_SESSION['_prefs']['loaded'] == true || !$_perpetual) {
-            return true;
-        }
-
-        // FIXME: Database query goes here....
-        return false;
-
-        $_SESSION['_prefs']['loaded'] = true;
-    }
-
-    /**
-     * Stores preferences to SQL server.
-     *
-     * @param array $prefs (optional) An array listing the preferences to be
-     *                     stored.  If not specified, store all of the
-     *                     preferences listed in the $prefs hash.
-     *
-     * @return mixed       True on success or a PEAR_Error object on failure.
-     */
-    function store($prefs=array())
-    {
-        // If we are not storing prefs in perpetually.
-        if (!$_perpetual) {
-            return true;
-        }
-
-        /*
-         * If a list of preferences to store hasn't been provided in
-         * $prefs, assume all preferences are desired.
-         */
-        if (empty($prefs)) {
-            $prefs =& $_SESSION['_prefs'];
-        } else if ($_SESSION['_prefs']['loaded'] == true) {
-            $prefs = array_merge($_SESSION['_prefs'], $prefs);
-        }
-
-        if (!is_array($prefs) || empty($prefs)) {
-            App::raiseMsg(_("No preferences are available."), MSG_ERR, __FILE__, __LINE__);
-            App::dieBoomerangURL();
-        }
-
-        // FIXME: Database query goes here....
-        return false;
-
     }
 
@@ -235,12 +93,10 @@
      * Perform cleanup operations.
      */
-    function cleanup()
+    function clear()
     {
-        $_SESSION['_prefs'] = array();
+        $_SESSION[$this->_ns] = array();
     }
 }
 
 
-
-
 ?>
Index: trunk/lib/RecordLock.inc.php
===================================================================
--- trunk/lib/RecordLock.inc.php	(revision 124)
+++ trunk/lib/RecordLock.inc.php	(revision 136)
@@ -1,8 +1,11 @@
 <?php
 /**
- * The RecordLock:: class provides a system for locking abstract DB rows.
+ * RecordLock.inc.php
+ * code by strangecode :: www.strangecode.com :: this document contains copyrighted information
+ *
+ * The RecordLock class provides a system for locking abstract DB rows.
  *
  * @author  Quinn Comendant <quinn@strangecode.com>
- * @version 2.0
+ * @version 2.1
  */
 class RecordLock {
@@ -32,11 +35,11 @@
     function &getInstance($auth_object)
     {
-        static $instances = array();
-
-        if (!isset($instances[$auth_object->getVal('auth_name')])) {
-            $instances[$auth_object->getVal('auth_name')] = new RecordLock($auth_object);
-        }
-
-        return $instances[$auth_object->getVal('auth_name')];
+        static $instance = null;
+
+        if ($instance === null) {
+            $instance = new RecordLock($auth_object);
+        }
+
+        return $instance;
     }
 
@@ -44,10 +47,12 @@
      * Constructor. Pass an Auth object on which to perform user lookups.
      *
-     * @param mixed  $auth_object  An Auth_SQL object.
+     * @param mixed  $auth_object  An Auth_SQL or Auth_FILE object.
      */
     function RecordLock($auth_object)
     {
-        if (!is_a($auth_object, 'Auth_SQL')) {
-            trigger_error('Constructor not provided a valid Auth_SQL object.', E_USER_ERROR);
+		$app =& App::getInstance();
+
+        if (!method_exists($auth_object, 'getVal') || !method_exists($auth_object, 'getUsername')) {
+            trigger_error('Constructor not provided a valid Auth_* object.', E_USER_ERROR);
         }
 
@@ -55,6 +60,6 @@
 
         // Get create tables config from global context.
-        if (!is_null(App::getParam('db_create_tables'))) {
-            $this->setParam(array('create_table' => App::getParam('db_create_tables')));
+        if (!is_null($app->getParam('db_create_tables'))) {
+            $this->setParam(array('create_table' => $app->getParam('db_create_tables')));
         }
     }
@@ -69,12 +74,15 @@
     function initDB($recreate_db=false)
     {
+		$app =& App::getInstance();
+		$db =& DB::getInstance();
+
         static $_db_tested = false;
 
         if ($recreate_db || !$_db_tested && $this->getParam('create_table')) {
             if ($recreate_db) {
-                DB::query("DROP TABLE IF EXISTS " . $this->getParam('db_table'));
-                App::logMsg(sprintf('Dropping and recreating table %s.', $this->getParam('db_table')), LOG_DEBUG, __FILE__, __LINE__);
+                $db->query("DROP TABLE IF EXISTS " . $this->getParam('db_table'));
+                $app->logMsg(sprintf('Dropping and recreating table %s.', $this->getParam('db_table')), LOG_DEBUG, __FILE__, __LINE__);
             }
-            DB::query("CREATE TABLE IF NOT EXISTS " . $this->getParam('db_table') . " (
+            $db->query("CREATE TABLE IF NOT EXISTS " . $this->getParam('db_table') . " (
                 lock_id int NOT NULL auto_increment,
                 record_table varchar(255) NOT NULL default '',
@@ -90,5 +98,5 @@
             )");
 
-            if (!DB::columnExists($this->getParam('db_table'), array(
+            if (!$db->columnExists($this->getParam('db_table'), array(
                 'lock_id',
                 'record_table',
@@ -99,5 +107,5 @@
                 'lock_datetime',
             ), false, false)) {
-                App::logMsg(sprintf('Database table %s has invalid columns. Please update this table manually.', $this->getParam('db_table')), LOG_ALERT, __FILE__, __LINE__);
+                $app->logMsg(sprintf('Database table %s has invalid columns. Please update this table manually.', $this->getParam('db_table')), LOG_ALERT, __FILE__, __LINE__);
                 trigger_error(sprintf('Database table %s has invalid columns. Please update this table manually.', $this->getParam('db_table')), E_USER_ERROR);
             }
@@ -120,16 +128,18 @@
 
     /**
-     * Return the value of a param setting.
-     *
-     * @access  public
-     * @param   string  $params Which param to return.
-     * @return  mixed   Configured param value.
+     * Return the value of a parameter, if it exists.
+     *
+     * @access public
+     * @param string $param        Which parameter to return.
+     * @return mixed               Configured parameter value.
      */
     function getParam($param)
     {
+		$app =& App::getInstance();
+    
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
         } else {
-            App::logMsg(sprintf('Parameter is not set: %s', $param), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
             return null;
         }
@@ -147,4 +157,7 @@
     function select($record_table_or_lock_id, $record_key=null, $record_val=null)
     {
+		$app =& App::getInstance();
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -154,24 +167,24 @@
         if (is_numeric($record_table_or_lock_id) && !isset($record_key) && !isset($record_val)) {
             // Get lock data by lock_id.
-            $qid = DB::query("
+            $qid = $db->query("
                 SELECT * FROM " . $this->getParam('db_table') . "
-                WHERE lock_id = '" . DB::escapeString($record_table_or_lock_id) . "'
+                WHERE lock_id = '" . $db->escapeString($record_table_or_lock_id) . "'
             ");
         } else {
             // Get lock data by record specs
-            $qid = DB::query("
+            $qid = $db->query("
                 SELECT * FROM " . $this->getParam('db_table') . "
-                WHERE record_table = '" . DB::escapeString($record_table_or_lock_id) . "'
-                AND record_key = '" . DB::escapeString($record_key) . "'
-                AND record_val = '" . DB::escapeString($record_val) . "'
+                WHERE record_table = '" . $db->escapeString($record_table_or_lock_id) . "'
+                AND record_key = '" . $db->escapeString($record_key) . "'
+                AND record_val = '" . $db->escapeString($record_val) . "'
             ");
         }
         if ($this->data = mysql_fetch_assoc($qid)) {
-            App::logMsg(sprintf('Selecting %slocked record: %s %s %s', ($this->data['set_by_admin_id'] == $this->_auth->getVal('user_id') ? 'self-' : ''), $record_table_or_lock_id, $record_key, $record_val), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Selecting %slocked record: %s %s %s', ($this->data['set_by_admin_id'] == $this->_auth->getVal('user_id') ? 'self-' : ''), $record_table_or_lock_id, $record_key, $record_val), LOG_DEBUG, __FILE__, __LINE__);
             /// FIX ME: What if admin set lock, but public user is current lock user?
             $this->data['editor'] = $this->_auth->getUsername($this->data['set_by_admin_id']);
             return true;
         } else {
-            App::logMsg(sprintf('No locked record: %s %s %s', $record_table_or_lock_id, $record_key, $record_val), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('No locked record: %s %s %s', $record_table_or_lock_id, $record_key, $record_val), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         }
@@ -196,8 +209,10 @@
     function isMine()
     {
+		$db =& DB::getInstance();
+	
         $this->initDB();
 
         if (isset($this->data['lock_id'])) {
-            $qid = DB::query("SELECT * FROM " . $this->getParam('db_table') . " WHERE lock_id = '" . DB::escapeString($this->data['lock_id']) . "'");
+            $qid = $db->query("SELECT * FROM " . $this->getParam('db_table') . " WHERE lock_id = '" . $db->escapeString($this->data['lock_id']) . "'");
             if ($lock = mysql_fetch_assoc($qid)) {
                 return ($lock['set_by_admin_id'] == $this->_auth->getVal('user_id'));
@@ -222,4 +237,6 @@
     function set($record_table, $record_key, $record_val, $title='')
     {
+		$db =& DB::getInstance();
+	
         $this->initDB();
 
@@ -228,13 +245,13 @@
 
         // Remove previous locks if exist. Is this better than using a REPLACE INTO?
-        DB::query("
+        $db->query("
             DELETE FROM " . $this->getParam('db_table') . "
-            WHERE record_table = '" . DB::escapeString($record_table) . "'
-            AND record_key = '" . DB::escapeString($record_key) . "'
-            AND record_val = '" . DB::escapeString($record_val) . "'
+            WHERE record_table = '" . $db->escapeString($record_table) . "'
+            AND record_key = '" . $db->escapeString($record_key) . "'
+            AND record_val = '" . $db->escapeString($record_val) . "'
         ");
 
         // Set new lock.
-        DB::query("
+        $db->query("
             INSERT INTO " . $this->getParam('db_table') . " (
                 record_table,
@@ -245,13 +262,13 @@
                 lock_datetime
             ) VALUES (
-                '" . DB::escapeString($record_table) . "',
-                '" . DB::escapeString($record_key) . "',
-                '" . DB::escapeString($record_val) . "',
-                '" . DB::escapeString($title) . "',
-                '" . DB::escapeString($this->_auth->getVal('user_id')) . "',
+                '" . $db->escapeString($record_table) . "',
+                '" . $db->escapeString($record_key) . "',
+                '" . $db->escapeString($record_val) . "',
+                '" . $db->escapeString($title) . "',
+                '" . $db->escapeString($this->_auth->getVal('user_id')) . "',
                 NOW()
             )
         ");
-        $lock_id = mysql_insert_id(DB::getDBH());
+        $lock_id = mysql_insert_id($db->getDBH());
 
         // Must register this locked record as the current.
@@ -266,4 +283,7 @@
     function remove()
     {
+		$app =& App::getInstance();
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -272,10 +292,10 @@
 
         // Delete a specific lock.
-        DB::query("
+        $db->query("
             DELETE FROM " . $this->getParam('db_table') . "
-            WHERE lock_id = '" . DB::escapeString($this->data['lock_id']) . "'
+            WHERE lock_id = '" . $db->escapeString($this->data['lock_id']) . "'
         ");
 
-        App::logMsg(sprintf('Removing lock: %s', $this->data['lock_id']), LOG_DEBUG, __FILE__, __LINE__);
+        $app->logMsg(sprintf('Removing lock: %s', $this->data['lock_id']), LOG_DEBUG, __FILE__, __LINE__);
     }
 
@@ -285,4 +305,7 @@
     function removeAll($user_id=null)
     {
+		$app =& App::getInstance();
+		$db =& DB::getInstance();
+
         $this->initDB();
 
@@ -292,10 +315,10 @@
         if (isset($user_id)) {
             // Delete specific user's locks.
-            DB::query("DELETE FROM " . $this->getParam('db_table') . " WHERE set_by_admin_id = '" . DB::escapeString($user_id) . "'");
-            App::logMsg(sprintf('Record locks owned by %s %s have been deleted', $this->_auth->getVal('auth_name'), $this->_auth->getUsername($user_id)), LOG_DEBUG, __FILE__, __LINE__);
+            $db->query("DELETE FROM " . $this->getParam('db_table') . " WHERE set_by_admin_id = '" . $db->escapeString($user_id) . "'");
+            $app->logMsg(sprintf('Record locks owned by %s %s have been deleted', $this->_auth->getVal('auth_name'), $this->_auth->getUsername($user_id)), LOG_DEBUG, __FILE__, __LINE__);
         } else {
             // Delete ALL locks.
-            DB::query("DELETE FROM " . $this->getParam('db_table') . "");
-            App::logMsg(sprintf('All record locks deleted by %s %s', $this->_auth->getVal('auth_name'), $this->_auth->getVal('username')), LOG_DEBUG, __FILE__, __LINE__);
+            $db->query("DELETE FROM " . $this->getParam('db_table') . "");
+            $app->logMsg(sprintf('All record locks deleted by %s %s', $this->_auth->getVal('auth_name'), $this->_auth->getVal('username')), LOG_DEBUG, __FILE__, __LINE__);
         }
     }
@@ -306,4 +329,6 @@
     function _auto_timeout()
     {
+		$db =& DB::getInstance();
+	
         static $_timeout_run = false;
 
@@ -312,5 +337,5 @@
         if (!$_timeout_run) {
             // Delete all old locks.
-            DB::query("
+            $db->query("
                 DELETE FROM " . $this->getParam('db_table') . "
                 WHERE DATE_ADD(lock_datetime, INTERVAL '" . $this->getParam('auto_timeout') . "' SECOND) < NOW()
@@ -325,5 +350,7 @@
     function dieErrorPage()
     {
-        App::dieURL(sprintf('%s?lock_id=%s&boomerang=%s', $this->getParam('error_url'), $this->data['lock_id'], urlencode(absoluteMe())));
+		$app =& App::getInstance();
+
+        $app->dieURL(sprintf('%s?lock_id=%s&boomerang=%s', $this->getParam('error_url'), $this->data['lock_id'], urlencode(absoluteMe())));
     }
 
@@ -333,7 +360,9 @@
     function printErrorHTML()
     {
+		$app =& App::getInstance();
+
         ?>
         <form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
-        <?php App::printHiddenSession() ?>
+        <?php $app->printHiddenSession() ?>
         <input type="hidden" name="lock_id" value="<?php echo $this->getID(); ?>" />
 
